import React, { Component } from 'react';
import logo from './logo.svg';
import {
  Route, BrowserRouter as Router, Link
} from 'react-router-dom';
import mqtt from 'mqtt';

import Home from './Home'
import Topics from './Topics'
import About from './About'
//import Page from './ReadInfo'

var client = false;

/*function initConnect(adresse) {
  socket = mqtt.connect(adresse);

  /*if(socket) {
    alert("SA MARCHE");
  }
  else {
    alert("SA MARCHE PAS");
  }*/

  /*socket.on('connect', function() {
    socket.subscribe('#'); // Vous avez souscrit à tous les messages du serveur !
  });

  socket.on('message', function(topic, payload) {
    document.getElementById('content').innerHTML += topic + "<br>";
  });

}*/

export class Sensor{

    constructor(data) {

      //console.log(data); // DEBUG

      this._id = data.id;
      this._name = data.name;
      this._type = data.type;
      this._err = null;

      this._data = data.data;

      if(data.data.values === undefined) {
          //this._values = data.data.value;
      }
      else {
          //this._values = data.data.values;
      }

      try {

        if(this._id === undefined) {
          throw "Erreur : (class Sensor) L'attribut _id n'est pas défini";
        }

        if(this._name === undefined) {
          throw "Erreur : (class Sensor) L'attribut _name n'est pas défini";
        }

        if(this._type === undefined) {
          throw "Erreur : (class Sensor) L'attribut _type n'est pas défini ou le type defini n'est pas <TEMPERATURE>";
        }

        /*if(this._values === undefined) {
          throw "Erreur : (class Sensor) L'attribut _values n'est pas défini";
        }*/
      }
      catch(err) {
        this._err = err;
      }

      //this._labels = data.data.labels;

      //Object.assign(this._data, data);
    }

    get id() {
      return this._id;
    }

    get name() {
      return this._name;
    }

    get type() {
      return this._type;
    }

    get value() {
      return this._data.values;
    }

    get lastValue() {

      if(typeof this._data.values === 'object' && this._data.values.length === 1) {
        return this._data.values;
      }
      else if(typeof this._data.values === 'string') {
        return this._data.values;
      }
      else if(typeof this._data.values === 'number') {
        return this._data.values;
      }
      else {
        return this._data.values[this._data.values.length-1];
      }
    }

    get lastDate() {
      if(typeof this._data.labels === 'object' && this._data.labels instanceof Date) {
        return this._data.labels.toLocaleString('fr-FR', { timeZone: 'Europe/Paris' });
      }
      else {
        return this._data.labels[this._data.labels.length-1].toLocaleString('fr-FR', { timeZone: 'Europe/Paris' });
      }
    }

    get labels() {
      return this._data.labels;
    }
}

let sensor = [];

const Page = ({sensor}) => {

  let arr = [];

  var sensor_values_read = "";
  var type_sensor_value = "";

  switch(sensor.type) {
    case "TEMPERATURE": sensor_values_read = "Température actuelle : " + sensor.lastValue+"°C"; break;
    case "ON_OFF": sensor_values_read = "Etat de mes yeux : " + sensor.lastValue; break;
    case "PERCENT": sensor_values_read = "Pourcentage actuelle : " + sensor.lastValue+"%"; break;
  }

  switch(sensor.type) {
    case "TEMPERATURE": type_sensor_value = "Température"; break;
    case "ON_OFF": type_sensor_value = "On_off"; break;
    case "PERCENT": type_sensor_value = "Pourcentage %"; break;
  }

  if(typeof sensor.value === 'object' && sensor.value.length !== undefined) {

    for(var i = 0; i < sensor.value.length; i++) {
        arr.push([{'labels': sensor.labels[i], 'value': sensor.value[i]}]);
    }

    var historique = arr.map(function(response) {

        var message = response;

        return (
          <tr>
          <td>
            {message[0].value}
          </td>
          <td>
            {message[0].labels.toLocaleString('fr-FR', { timeZone: 'Europe/Paris' })}
          </td>
          </tr>
        );
    });
  }

  return (
      <div><h1>{sensor_values_read} (<i>Date de dernière mise à jour : {sensor.lastDate}</i>)</h1>

      <br />

      <table border="1">
        <thead>
        <tr>
          <th colspan="2"><h1>Historique</h1></th>
        </tr>
        <tr>
          <th>{type_sensor_value}</th>
          <th>Dernière maj</th>
        </tr>
        </thead>
        <tbody>
          {historique || 'Aucun historique disponible pour ce capteur'}
        </tbody>
      </table></div>
  );
}

class App extends Component {

  constructor(props) {
    super(props);
    this.state = {value: 'mqtt://127.0.0.1:8080', error: null, messages: [], capteurs: [], sensor: [], path: "" };

    this.handleChange = this.handleChange.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
  }

  addMessage(message) {
      var updated = this.state.messages;
      updated.push(message);
      this.setState({messages: updated});
  }

  addCapteur(sensor) {
      var sensorUpdated = this.state.capteurs;
      sensorUpdated.push(sensor);
      this.setState({capteurs: sensorUpdated});
  }

  addDataSensor(sensor) {
      var sensorUpdated = this.state.sensor;
      sensorUpdated.push(sensor);
      this.setState({sensor: sensorUpdated});
  }

  getSensorLength() {
    return sensor;
  }

  getInitialState() {
      return { messages: [] };
  }

  updateDataSensor(id, obj) {
    var newsensor = this.state.sensor;
    newsensor[id] = obj;
    this.setState({ sensor: newsensor[id] });
  }

  handleChange(event) {
    this.setState({value: event.target.value});
  }

  handleSubmit(event) {

    event.preventDefault();
    client = mqtt.connect(this.state.value);

    client.on('connect', function() {
      client.subscribe("#");
    });

    var self = this;

    const prefixTopic = "value/";
    var id = 1;

    var i = 0;

    sensor = [];

    this.setState({sensor: []});

    this.setState({capteurs: []});

    this.setState({messages: []});

    var listCapteurs = [];

    Array.prototype.contains = function(obj) {
      var i = this.length;
      while (i--) {
          if (this[i] === obj) {
              return true;
          }
      }
      return false;
    }

    client.on('message', function(topic, payload, packet) {

        const obj = JSON.parse(payload.toString());

        var name = topic.replace(prefixTopic,"");

        obj.id = id;
        obj.name = name;

        if(obj.type !== "ON_OFF") {
          obj.value = parseFloat(obj.value);

          if(obj.type === "PERCENT") {
            obj.value = (Math.round(obj.value * 10) / 10)*100;
          }
          else {
            obj.value = Math.round(obj.value * 10) / 10;
          }
        }

        var firstDate = "";

        if(!listCapteurs.contains(name)) {

              //console.log(topic);

              var data = {};
              data.values = obj.value;
              data.labels = new Date();
              obj.data = data;

              sensor[i] = new Sensor(obj);

              listCapteurs.push(name);

              i++;
              id++;

              // On ajoute nos capteurs
              self.addCapteur({

                  name: name,
                  url: "/"+name,
                  sensor: new Sensor(obj)
              });

              self.addMessage({
                  key: Date.now(),
                  topic: topic,
                  payload: payload.toString(),
                  name: name,
                  value: obj.value
              });

              // on ajoute dans notre liste chaque info de capteurs
              self.addDataSensor({
                  sensor: new Sensor(obj)
              });
        }
        else {

              for(var k = 0; k < self.getSensorLength().length; k++) {

                if(self.getSensorLength()[k].name === name) {

                  var date = new Date();

                  if(typeof self.getSensorLength()[k]._data.values !== "array" && self.getSensorLength()[k]._data.labels instanceof Date) {
                    if(self.getSensorLength()[k].type !== 'ON_OFF') {
                      var firstValue = self.getSensorLength()[k]._data.values;
                      self.getSensorLength()[k]._data.values = [];
                      self.getSensorLength()[k]._data.values.push(firstValue);
                      self.getSensorLength()[k]._data.values.push(obj.value);
                      firstDate = self.getSensorLength()[k]._data.labels;
                      self.getSensorLength()[k]._data.labels = [];
                      self.getSensorLength()[k]._data.labels.push(firstDate);
                      self.getSensorLength()[k]._data.labels.push(date);
                    }
                    else {
                      self.getSensorLength()[k]._data.values = obj.value;
                      firstDate = self.getSensorLength()[k]._data.labels;
                      self.getSensorLength()[k]._data.labels = [];
                      self.getSensorLength()[k]._data.labels.push(firstDate);
                      self.getSensorLength()[k]._data.labels.push(date);
                    }
                  }
                  else {
                    if(typeof self.getSensorLength()[k]._data.values === "string" && self.getSensorLength()[k].type === 'ON_OFF') {

                      // A chaque changement des yeux
                      self.getSensorLength()[k]._data.values = obj.value;
                      self.getSensorLength()[k]._data.labels.push(date);

                    }
                    else
                    {
                      if(self.getSensorLength()[k]._data.values.length === 10 && self.getSensorLength()[k]._data.labels.length === 10) {
                        /*self.getSensorLength()[k]._data.values[0].push(obj.value);
                        self.getSensorLength()[k]._data.labels[0].push(date);*/
                        for(var m = self.getSensorLength()[k]._data.values.length-1; m > 0; m--) {
                          self.getSensorLength()[k]._data.values[m-1] = self.getSensorLength()[k]._data.values[m];
                          self.getSensorLength()[k]._data.labels[m-1] = self.getSensorLength()[k]._data.labels[m];
                        }

                        self.getSensorLength()[k]._data.values.splice(-1, 1);
                        self.getSensorLength()[k]._data.labels.splice(-1, 1);
                      }
                      else {

                        self.getSensorLength()[k]._data.values.push(obj.value);
                        self.getSensorLength()[k]._data.labels.push(date);
                      }

                    }
                  }

                  self.updateDataSensor(k, self.getSensorLength()[k]);

               }
              }
          }
    });
  }

  render() {

    /* Messages globales */
    var messageNodes = this.state.messages.map(function(message) {
        return (
            <div key={message.key} className="message"><h1>{message.value}</h1></div>
        );
    });

    // Mon Historique de messages */
    var historique = this.state.capteurs.map(function(message) {
        return (
            <div key={message.sensor.id} className="message">{message.sensor.name}</div>
        );
    });

    /* Création de link capteurs dynamique */
    var linkCapteurs = this.state.capteurs.map(function(capteurs) {

        return (
          <li><Link to={capteurs.url}><button type="button">{capteurs.name}</button></Link></li>
        );
    });

    /* Création de route de capteurs dynamique */
    var routeCapteurs = this.state.capteurs.map(function(capteurs) {
        return (
          <Route path={capteurs.url} params={capteurs.sensor} render={(props) => (
            <Page sensor={capteurs.sensor} />
          )}/>
        );
    });

    return (
      <div className="App">

            <header><h1>URL du Brocker : <form onSubmit={this.handleSubmit}><input type="text" value={this.state.value}  onChange={this.handleChange} required/> <input type="submit" value="Tester la connexion"/></form></h1></header>

            <Router>
            <div className="wrapper">

              <nav><ul role="nav">
                <div>
                  <li><Link to="/home"><button type="button">Home</button></Link></li>
                  <hr />
                  <div id="dynamiqueNav">
                    <h3>Navigation</h3>
                    {linkCapteurs}
                    <hr />
                  </div>
                </div>
              </ul></nav>
              <article>
                  <Route path="/home" component={Home}/>
                  <div id="messageList" className="table-block footer-push">
                    {routeCapteurs}
                    <div id="content">
                    </div>
                  </div>
              </article>
            </div>
            </Router>

            <footer>@Copyright Julien SAUTEREAU - Tout droit réservé</footer>
            </div>
          );
        }
}

export default App;
