import React from 'react'
import mqtt from 'mqtt'

var client = mqtt.connect("mqtt://127.0.0.1:8080");

client.on('connect', function() {
  client.subscribe("#");
});

class Messages extends React.Component {

  addMessage(message) {
      var updated = this.state.messages;
      updated.push(message);
      this.setState({messages: updated});
  }

  getInitialState() {
      return { messages: [] };
  }

  handleChange(event) {
    this.setState({value: event.target.value});
  }

  componentDidMount() {
      var self = this;

      client.on('message', function(topic, payload, packet) {
          self.addMessage({
              key: Date.now(),
              topic: topic,
              payload: payload.toString()
          });
      });
  }

  render() {
      var messageNodes = this.state.messages.map(function(message) {
          return (
              <div key={message.key} message={message} />
          );
      });

      return (
          <div id="messageList" className="table-block footer-push">
              <h1>Messages reçus</h1>
              <div className="messages">{messageNodes}</div>
          </div>
      );
    }
}

export default Messages
